/*
 * このソースコードは blanco Frameworkによって自動生成されています。
 * Apache Antタスク [BlancoDbMetaDataMeta2Csv]の抽象親クラス
 */
package blanco.dbmetadata.task;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

/**
 * Apache Antタスク [BlancoDbMetaDataMeta2Csv]の抽象親クラス。
 *
 * データベースメタ情報からCSVを自動生成するためのAntTaskです。<br>
 * この抽象親クラスでは、Apache Antタスクで一般的に必要なチェックなどのコーディングを肩代わりします。
 * このクラスを継承して、パッケージ[blanco.dbmetadata.task]にBlancoDbMetaDataMeta2CsvTaskクラスを作成してください。そしてAntタスクの処理内容を記述してください。<br>
 * <br>
 * Antタスクへの組み込み例<br>
 * <pre>
 * &lt;taskdef name=&quot;blancodbmetadatameta2csv&quot; classname=&quot;blanco.dbmetadata.task.BlancoDbMetaDataMeta2CsvTask">
 *     &lt;classpath&gt;
 *         &lt;fileset dir=&quot;lib&quot; includes=&quot;*.jar&quot; /&gt;
 *         &lt;fileset dir=&quot;lib.ant&quot; includes=&quot;*.jar&quot; /&gt;
 *     &lt;/classpath&gt;
 * &lt;/taskdef&gt;
 * </pre>
 */
public abstract class AbstractBlancoDbMetaDataMeta2CsvTask extends Task {
    /**
     * Verboseモードで動作させるかどうか。
     */
    private String fVerbose = "false";

    /**
     * Antタスクの[jdbcdriver]アトリビュート。
     *
     * 項目番号: 1<br>
     * JDBCドライバ名を指定します。<br>
     * 必須項目<br>
     */
    private String fJdbcdriver;

    /**
     * Antタスクの[jdbcurl]アトリビュート。
     *
     * 項目番号: 2<br>
     * JDBC接続先URLを指定します。<br>
     * 必須項目<br>
     */
    private String fJdbcurl;

    /**
     * Antタスクの[jdbcuser]アトリビュート。
     *
     * 項目番号: 3<br>
     * 必須項目<br>
     */
    private String fJdbcuser;

    /**
     * Antタスクの[jdbcpassword]アトリビュート。
     *
     * 項目番号: 4<br>
     * 必須項目<br>
     */
    private String fJdbcpassword;

    /**
     * Antタスクの[schema]アトリビュート。
     *
     * 項目番号: 5<br>
     * スキーマ情報。Oracleの場合にはユーザ名を与える必要があります。<br>
     */
    private String fSchema;

    /**
     * Antタスクの[table]アトリビュート。
     *
     * 項目番号: 6<br>
     * 指定された場合には、その表のみを処理します。<br>
     */
    private String fTable;

    /**
     * Antタスクの[targetdir]アトリビュート。
     *
     * 項目番号: 7<br>
     * 出力先フォルダを指定します。無指定の場合にはカレント直下のblancoを用います。<br>
     */
    private String fTargetdir;

    /**
     * Antタスクの[tmpdir]アトリビュート。
     *
     * 項目番号: 8<br>
     * テンポラリディレクトリを指定します。無指定の場合にはカレント直下のtmpを用います。<br>
     */
    private String fTmpdir;

    /**
     * Verboseモードで動作させるかどうか。
     *
     * @param arg Verboseモードで動作させるかどうか。
     */
    public void setVerbose(final String arg) {
        fVerbose = arg;
    }

    /**
     * Verboseモードで動作させるかどうか。
     *
     * @return Verboseモードで動作させるかどうか。
     */
    public String getVerbose() {
        return fVerbose;
    }

    /**
     * Antタスクの[jdbcdriver]アトリビュートのセッターメソッド。
     *
     * 項目番号: 1<br>
     * JDBCドライバ名を指定します。<br>
     *
     * @param arg セットしたい値
     */
    public void setJdbcdriver(final String arg) {
        fJdbcdriver = arg;
    }

    /**
     * Antタスクの[jdbcdriver]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 1<br>
     * JDBCドライバ名を指定します。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getJdbcdriver() {
        return fJdbcdriver;
    }

    /**
     * Antタスクの[jdbcurl]アトリビュートのセッターメソッド。
     *
     * 項目番号: 2<br>
     * JDBC接続先URLを指定します。<br>
     *
     * @param arg セットしたい値
     */
    public void setJdbcurl(final String arg) {
        fJdbcurl = arg;
    }

    /**
     * Antタスクの[jdbcurl]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 2<br>
     * JDBC接続先URLを指定します。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getJdbcurl() {
        return fJdbcurl;
    }

    /**
     * Antタスクの[jdbcuser]アトリビュートのセッターメソッド。
     *
     * 項目番号: 3<br>
     *
     * @param arg セットしたい値
     */
    public void setJdbcuser(final String arg) {
        fJdbcuser = arg;
    }

    /**
     * Antタスクの[jdbcuser]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 3<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getJdbcuser() {
        return fJdbcuser;
    }

    /**
     * Antタスクの[jdbcpassword]アトリビュートのセッターメソッド。
     *
     * 項目番号: 4<br>
     *
     * @param arg セットしたい値
     */
    public void setJdbcpassword(final String arg) {
        fJdbcpassword = arg;
    }

    /**
     * Antタスクの[jdbcpassword]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 4<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getJdbcpassword() {
        return fJdbcpassword;
    }

    /**
     * Antタスクの[schema]アトリビュートのセッターメソッド。
     *
     * 項目番号: 5<br>
     * スキーマ情報。Oracleの場合にはユーザ名を与える必要があります。<br>
     *
     * @param arg セットしたい値
     */
    public void setSchema(final String arg) {
        fSchema = arg;
    }

    /**
     * Antタスクの[schema]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 5<br>
     * スキーマ情報。Oracleの場合にはユーザ名を与える必要があります。<br>
     *
     * @return このフィールドの値
     */
    public String getSchema() {
        return fSchema;
    }

    /**
     * Antタスクの[table]アトリビュートのセッターメソッド。
     *
     * 項目番号: 6<br>
     * 指定された場合には、その表のみを処理します。<br>
     *
     * @param arg セットしたい値
     */
    public void setTable(final String arg) {
        fTable = arg;
    }

    /**
     * Antタスクの[table]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 6<br>
     * 指定された場合には、その表のみを処理します。<br>
     *
     * @return このフィールドの値
     */
    public String getTable() {
        return fTable;
    }

    /**
     * Antタスクの[targetdir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 7<br>
     * 出力先フォルダを指定します。無指定の場合にはカレント直下のblancoを用います。<br>
     *
     * @param arg セットしたい値
     */
    public void setTargetdir(final String arg) {
        fTargetdir = arg;
    }

    /**
     * Antタスクの[targetdir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 7<br>
     * 出力先フォルダを指定します。無指定の場合にはカレント直下のblancoを用います。<br>
     * デフォルト値[blanco.db]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getTargetdir() {
        return fTargetdir;
    }

    /**
     * Antタスクの[tmpdir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 8<br>
     * テンポラリディレクトリを指定します。無指定の場合にはカレント直下のtmpを用います。<br>
     *
     * @param arg セットしたい値
     */
    public void setTmpdir(final String arg) {
        fTmpdir = arg;
    }

    /**
     * Antタスクの[tmpdir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 8<br>
     * テンポラリディレクトリを指定します。無指定の場合にはカレント直下のtmpを用います。<br>
     * デフォルト値[tmp]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getTmpdir() {
        return fTmpdir;
    }

    /**
     * 実際のAntTaskの処理について、このメソッドをオーバーライドします。
     *
     * @throws IllegalArgumentException 引数や入出力などについて例外が発生した場合。
     */
    protected abstract void process() throws IllegalArgumentException;

    /**
     * Antタスクのメイン処理。Apache Antから このメソッドが呼び出されます。
     *
     * @throws BuildException タスクとしての例外が発生した場合。
     */
    public final void execute() throws BuildException {
        System.out.println("BlancoDbMetaDataMeta2CsvTask begin.");

        // 項目番号[1]、アトリビュート[jdbcdriver]は必須入力です。入力チェックを行います。
        if (getJdbcdriver() == null) {
            throw new BuildException("アトリビュート[jdbcdriver]が設定されていません。処理を中断します。");
        }
        // 項目番号[2]、アトリビュート[jdbcurl]は必須入力です。入力チェックを行います。
        if (getJdbcurl() == null) {
            throw new BuildException("アトリビュート[jdbcurl]が設定されていません。処理を中断します。");
        }
        // 項目番号[3]、アトリビュート[jdbcuser]は必須入力です。入力チェックを行います。
        if (getJdbcuser() == null) {
            throw new BuildException("アトリビュート[jdbcuser]が設定されていません。処理を中断します。");
        }
        // 項目番号[4]、アトリビュート[jdbcpassword]は必須入力です。入力チェックを行います。
        if (getJdbcpassword() == null) {
            throw new BuildException("アトリビュート[jdbcpassword]が設定されていません。処理を中断します。");
        }
        // 項目番号[7]、アトリビュート[targetdir]にはデフォルトが設定されています。入力がnullの場合にはデフォルト値をセットします。
        if (getTargetdir() == null) {
            setTargetdir("blanco.db");
        }
        // 項目番号[8]、アトリビュート[tmpdir]にはデフォルトが設定されています。入力がnullの場合にはデフォルト値をセットします。
        if (getTmpdir() == null) {
            setTmpdir("tmp");
        }

        if ("true".equals(getVerbose())) {
            System.out.println("- verbose:[true]");
            System.out.println("- jdbcdriver:[" + getJdbcdriver() + "]");
            System.out.println("- jdbcurl:[" + getJdbcurl() + "]");
            System.out.println("- jdbcuser:[" + getJdbcuser() + "]");
            System.out.println("- jdbcpassword:[" + getJdbcpassword() + "]");
            System.out.println("- schema:[" + getSchema() + "]");
            System.out.println("- table:[" + getTable() + "]");
            System.out.println("- targetdir:[" + getTargetdir() + "]");
            System.out.println("- tmpdir:[" + getTmpdir() + "]");
        }

        try {
            // 実際のAntタスクの主処理を実行します。
            process();
        } catch (IllegalArgumentException e) {
            if ("true".equals(getVerbose())) {
                e.printStackTrace();
            }
            throw new BuildException(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中に例外が発生しました。処理を中断します。" + e.toString());
        } catch (Error e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中にエラーが発生しました。処理を中断します。" + e.toString());
        }
    }
}
